case $CONFIG in
    '') . ../conf.sh ;;
esac
echo "Extracting bqueue (with variable substitutions)"
$spitshell >bqueue <<!GROK!THIS!
$startsh
# Batch Queue command.
#    bqueue [-q reg_exp] [ -all ] [ userid ... ]
# The command defaults to listing all users' jobs waiting in all queues.
# "-all" means NOT all, i.e. only me.  Little arg checking is done.
# This will mess up if you pass an arg that is not a valid
# awk regular expression, e.g. bqueue "*" or ""
# I don't use FIND because this ls into awk is faster (!)
# and because I can sort on queue order this way.  (The queue order
# is based on the file name.  The third letter is priority.)
# -IAN!
#
# $Header$
#
# $Log$
# Revision 1.4  1995/11/27 05:04:00  geoff
# *** empty log message ***
#
# Revision 1.3  87/01/10  23:28:44  geoff
# Fix a couple of minor problems found during portability testing.
# 
# Revision 1.2  86/11/29  15:59:51  geoff
# Major changes to make batchqueue into bqueue.SH, making it configurable.
# 
#
PATH=$defpath
export PATH
batchdir=$bspoolexp
echo=$echo
sed=$sed
who=$who
find=$find
ls=$ls
awk=$awk
grep=$grep
!GROK!THIS!
cat >>bqueue <<'!NO!SUBS!'

dirs=*
case "$1" in
-q)
	shift
	case $# in
	0)
		$echo bqueue: queue list missing, default used
		;;
	*)
		dirs=$1
		shift
		;;
	esac
	;;
esac

case "$1" in
-a*)
	id=${USER-`$who am i | $sed 's/ .*$//'`}
	shift
	;;
+a*)
	shift
	;;
esac

case $# in
0)
	case "$id" in
	"")
		id=".*"
		;;
	esac
	;;
*)
	case "$id" in
	"")
		id="$1"
		shift
		;;
	esac
	for x do
		id="$id|$1"
		shift
	done
	;;
esac

cd $batchdir
for dir in $dirs ; do
	if test ! -d "$dir"; then
		continue
	fi
	cd $dir
	$echo ">>-- $dir queue --<<"
	for file in `$ls -l cf* 2>/dev/null | $awk "/ ($id) /"' { print $NF }'`
	do
		$ls -l $file | $awk \
			'{if (NF==8)
			  printf ("%-12s %s %s %s   %s\n", $3, $5, $6, $7, $8)
			else
			  printf ("%-12s %s %s %s   %s\n", $3, $6, $7, $8, $9)}'
		$grep 2>/dev/null "JOB CANCELLED" $file || \
			$sed	-e '1,/set home=/d
				/^$/d
				s/  */ /g;s/^ */  /;
				/IhOpEtHiSiSuNiQuE!/d' \
				2>/dev/null $file
	done
	cd ..
done
exit 0
!NO!SUBS!
$eunicefix bqueue
chmod 755 bqueue
