case $CONFIG in
    '') . ../conf.sh ;;
esac
echo "Extracting makeq (with variable substitutions)"
$spitshell >makeq <<!GROK!THIS!
$startsh
export PATH || (echo "OOPS, this isn't sh.  Desperation time.  I will feed myself to sh."; sh \$0; kill \$\$)
#
#	Command to make (or remake) a new batch queue
#
#	Usage:
#
#	makeq queue-name
#
# $Header$
#
# $Log$
# Revision 1.2  1995/11/27 05:04:10  geoff
# Cosmetic RCS header changes.
#
# Revision 1.1  87/03/31  22:55:14  geoff
# Initial revision
# 
#
PATH=$defpath
export PATH
batchdir=$bspoolexp
cat=$cat
echo=$echo
expr=$expr
test=$test
mkdir=$mkdir
n="$n"
c="$c"
owner=$daemon
group=$daemongid
loadavg=$loadavg
resourceh=$resourceh
rm=$rm
sed=$sed
sigstop=$sigstop
ulimit=$ulimit
!GROK!THIS!
cat >>makeq <<'!NO!SUBS!'
if $test ! -w /etc/passwd
then
    $echo "makeq must be run by root"
    exit 1
fi
case "$1" in
    '') $echo Usage: makeq queue-name 1>&2
	exit 1
	;;
esac
queue=$1
#
# Initialize queue parameters to defaults
#
exec='on'
maxexec=''
supervisor=$batchdir/$queue/This_week
mail='ec'
mailsupervisor='ec'
nice='10'
restart='y'
loadstop=''
loadsched=''
cpulimit=''
rlimitcpu=''
rlimitfsize=''
rlimitdata=''
rlimitstack=''
rlimitcore=''
rlimitrss=''
ulimitfsize=''

if $test -d $batchdir/$queue
then
    $echo "Queue '$queue' already exists.  Current parameters:"
    $cat $batchdir/$queue/profile
    TMP=/tmp/mq$$
    trap "$rm -f ${TMP}" 1 2 15
    $sed -e "s/ /='/" -e 's/$/'"'/" -e "s/restart/restart=restart/" \
      $batchdir/$queue/profile > ${TMP}
    . ${TMP}
    $rm -f ${TMP}
    trap 1 2 15
    case "$restart" in
	y) restart='' ;;
    esac
fi
ok=n
while $test "$ok" = n
do
    case "$exec" in
	on) dflt=y ;;
	*)  dflt=n ;;
    esac
    $echo $n "Do you want to permit jobs to execute on the '$queue' queue? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	y*) exec=on ;;
	n*) case "$exec" in
		drain) dflt=n ;;
		*) dflt=y ;;
	    esac
	    $echo $n "Do you want to abort any current jobs? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		y*) exec=off ;;
		n*) exec=drain ;;
	    esac
	    ;;
    esac
    case "$maxexec" in
	'') dflt="1" ;;
	*)  dflt=$maxexec ;;
    esac
    $echo "For the next question, answer 'none' if there is no maximum."
    $echo $n "What is the maximum number of simultaneous jobs? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	none) maxexec='' ;;
	*) maxexec=$ans ;;
    esac
    case "$nice" in
	'') dflt="10" ;;
	*)  dflt=$nice ;;
    esac
    $echo $n "What nice level should jobs be run at? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	none) nice='' ;;
	*) nice=$ans ;;
    esac
    case "$supervisor" in
	'') dflt=none ;;
	*)  dflt="$supervisor" ;;
    esac
    $echo "For the next question, answer 'none' if there is no supervisor."
    $echo "The supervisor may be either an absolute path name or a mail address."
    $echo $n "What is the supervisor for the '$queue' queue? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	none) supervisor='' ;;
	*) supervisor="$ans" ;;
    esac
    case "$mail" in
	*s*) dflt=y ;;
	*) dflt=n ;;
    esac
    $echo $n "Should the user receive mail when a jub starts? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	y*) mailconds=s ;;
	*)  mailconds='' ;;
    esac
    case "$mail" in
	*e*) dflt=y ;;
	*) dflt=n ;;
    esac
    $echo $n "Should the user receive mail when a jub completes? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	y*) mailconds="${mailconds}e" ;;
    esac
    case "$mail" in
	*c*) dflt=y ;;
	*) dflt=n ;;
    esac
    $echo "Should the user receive mail when a jub is restarted after"
    $echo $n "a crash? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	y*) mailconds="${mailconds}c" ;;
    esac
    mail="$mailconds"
    case "$supervisor" in
	/*) supfile="supervisor file receive a line" ;;
	*)  supfile="supervisor receive mail" ;;
    esac
    case "$mailsupervisor" in
	*s*) dflt=y ;;
	*) dflt=n ;;
    esac
    $echo $n "Should the $supfile when a jub starts? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	y*) mailconds=s ;;
	*)  mailconds='' ;;
    esac
    case "$mailsupervisor" in
	*e*) dflt=y ;;
	*) dflt=n ;;
    esac
    $echo $n "Should the $supfile when a jub completes? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	y*) mailconds="${mailconds}e" ;;
    esac
    case "$mailsupervisor" in
	*c*) dflt=y ;;
	*) dflt=n ;;
    esac
    $echo "Should the $supfile when a jub is restarted after"
    $echo $n "a crash? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	y*) mailconds="${mailconds}c" ;;
    esac
    mailsupervisor="$mailconds"
    case "$loadavg" in
	define)
	    set X $loadsched
	    shift
	    case "$1" in
		'') dflt="200.0 200.0 2 2" ;;
		*)  dflt=$1 ;;
	    esac
	    $echo $n "At what load average should job scheduling be stopped? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    loadsched=$ans
	    case "$3" in
		'') dflt="medium" ;;
		0)  dflt="short" ;;
		1)  dflt="medium" ;;
		*)  dflt="long" ;;
	    esac
	    $echo "Should the short, medium, or long-term average"
	    $echo $n " be used for this decision? [$dflt] $c"
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		s*) stopavg=0 ;;
		m*) stopavg=1 ;;
		*)  stopavg=2 ;;
	    esac
	    case "$2" in
		'') dflt=$loadsched ;;
		*)  dflt=$2 ;;
	    esac
	    $echo $n "At what load average should job scheduling be restarted? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') loadstart=$dflt ;;
		*)  loadstart=$ans ;;
	    esac
	    case "$4" in
		'') dflt="long" ;;
		0)  dflt="short" ;;
		1)  dflt="medium" ;;
		*)  dflt="long" ;;
	    esac
	    $echo "Should the short, medium, or long-term average"
	    $echo $n " be used for this decision? [$dflt] $c"
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		s*) startavg=0 ;;
		m*) startavg=1 ;;
		*)  startavg=2 ;;
	    esac
	    loadsched="$loadsched $loadstart $stopavg $startavg"
	    ;;
    esac
    case "$loadavg$sigstop" in
	definedefine)
	    set X $loadstop
	    shift
	    case "$1" in
		'') dflt="200.0 200.0 2 2" ;;
		*)  dflt=$1 ;;
	    esac
	    $echo $n "At what load average should running jobs be stopped? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    loadstop=$ans
	    case "$3" in
		'') dflt="short" ;;
		0)  dflt="short" ;;
		1)  dflt="medium" ;;
		*)  dflt="long" ;;
	    esac
	    $echo "Should the short, medium, or long-term average"
	    $echo $n " be used for this decision? [$dflt] $c"
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		s*) stopavg=0 ;;
		m*) stopavg=1 ;;
		*)  stopavg=2 ;;
	    esac
	    case "$2" in
		'') dflt=$loadstop ;;
		*)  dflt=$2 ;;
	    esac
	    $echo $n "At what load average should stopped jobs be restarted? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') loadstart=$dflt ;;
		*)  loadstart=$ans ;;
	    esac
	    case "$4" in
		'') dflt="medium" ;;
		0)  dflt="short" ;;
		1)  dflt="medium" ;;
		*)  dflt="long" ;;
	    esac
	    $echo "Should the short, medium, or long-term average"
	    $echo $n " be used for this decision? [$dflt] $c"
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		s*) startavg=0 ;;
		m*) startavg=1 ;;
		*)  startavg=2 ;;
	    esac
	    loadstop="$loadstop $loadstart $stopavg $startavg"
	    ;;
    esac
    case "$restart" in
	'') dflt=n ;;
	*)  dflt=y ;;
    esac
    $echo $n "Should jobs be restarted after a crash? [$dflt] $c"
    read ans
    case "$ans" in
	'') ans=$dflt ;;
    esac
    case "$ans" in
	y*) restart=restart ;;
	*)  restart='' ;;
    esac
    case "$resourceh" in
	define)
	    case "$rlimitcpu" in
		'') dflt=none ;;
		*)  dflt=$rlimitcpu ;;
	    esac
	    $echo "You may answer any limit question with 'none' if you choose."
	    $echo $n "What is the CPU time limit in seconds for this queue? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		none) rlimitcpu='' ;;
		*) rlimitcpu=$ans ;;
	    esac
	    case "$rlimitfsize" in
		'') dflt=none ;;
		*)  dflt=$rlimitfsize ;;
	    esac
	    $echo $n "What is the file size limit in bytes for this queue? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		none) rlimitfsize='' ;;
		*) rlimitfsize=$ans ;;
	    esac
	    case "$rlimitdata" in
		'') dflt=none ;;
		*)  dflt=$rlimitdata ;;
	    esac
	    $echo $n "What is the data segment size limit in bytes for this queue? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		none) rlimitdata='' ;;
		*) rlimitdata=$ans ;;
	    esac
	    case "$rlimitstack" in
		'') dflt=none ;;
		*)  dflt=$rlimitstack ;;
	    esac
	    $echo $n "What is the stack segment size limit in bytes for this queue? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		none) rlimitstack='' ;;
		*) rlimitstack=$ans ;;
	    esac
	    case "$rlimitcore" in
		'') dflt=none ;;
		*)  dflt=$rlimitcore ;;
	    esac
	    $echo $n "What is the core dump size limit in bytes for this queue? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		none) rlimitcore='' ;;
		*) rlimitcore=$ans ;;
	    esac
	    case "$rlimitrss" in
		'') dflt=none ;;
		*)  dflt=$rlimitrss ;;
	    esac
	    $echo $n "What is the working set size limit in bytes for this queue? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		none) rlimitrss='' ;;
		*) rlimitrss=$ans ;;
	    esac
	    ;;
    esac
    case "ulimit" in
	define)
	    case "$ulimitfsize" in
		'') dflt=none ;;
		*)  dflt=$ulimitfsize ;;
	    esac
	    $echo $n "What is the file size limit in bytes for this queue? [$dflt] $c"
	    read ans
	    case "$ans" in
		'') ans=$dflt ;;
	    esac
	    case "$ans" in
		none) ulimitfsize='' ;;
		*) ulimitfsize=`$exp $ans / 512` ;;
	    esac
	    ;;
    esac
    $echo $n "Is this satisfactory? [y] $c"
    read ans
    case "$ans" in
	''|y*) ok=y ;;
    esac
done
if $test ! -d $batchdir/$queue
then
    $mkdir $batchdir/$queue
    chmod 755 $batchdir/$queue
    chown $owner $batchdir/$queue
    chgrp $group $batchdir/$queue
fi
> $batchdir/$queue/profile
case "$exec" in
    '') ;;
    *)  $echo "exec $exec" >> $batchdir/$queue/profile ;;
esac
case "$maxexec" in
    '') ;;
    *)  $echo "maxexec $maxexec" >> $batchdir/$queue/profile ;;
esac
case "$supervisor" in
    '') ;;
    *)  $echo "supervisor $supervisor" >> $batchdir/$queue/profile ;;
esac
case "$mail" in
    '') ;;
    *)  $echo "mail $mail" >> $batchdir/$queue/profile ;;
esac
case "$mailsupervisor" in
    '') ;;
    *)  $echo "mailsupervisor $mailsupervisor" >> $batchdir/$queue/profile ;;
esac
case "$loadsched" in
    '') ;;
    *)  $echo "loadsched $loadsched" >> $batchdir/$queue/profile ;;
esac
case "$loadstop" in
    '') ;;
    *)  $echo "loadstop $loadstop" >> $batchdir/$queue/profile ;;
esac
case "$nice" in
    '') ;;
    *)  $echo "nice $nice" >> $batchdir/$queue/profile ;;
esac
case "$restart" in
    '') ;;
    *)  $echo "restart" >> $batchdir/$queue/profile ;;
esac
case "$rlimitcpu" in
    '') ;;
    *)  $echo "rlimitcpu $rlimitcpu" >> $batchdir/$queue/profile ;;
esac
case "$rlimitfsize" in
    '') ;;
    *)  $echo "rlimitfsize $rlimitfsize" >> $batchdir/$queue/profile ;;
esac
case "$rlimitdata" in
    '') ;;
    *)  $echo "rlimitdata $rlimitdata" >> $batchdir/$queue/profile ;;
esac
case "$rlimitstack" in
    '') ;;
    *)  $echo "rlimitstack $rlimitstack" >> $batchdir/$queue/profile ;;
esac
case "$rlimitcore" in
    '') ;;
    *)  $echo "rlimitcore $rlimitcore" >> $batchdir/$queue/profile ;;
esac
case "$rlimitrss" in
    '') ;;
    *)  $echo "rlimitrss $rlimitrss" >> $batchdir/$queue/profile ;;
esac
case "$ulimitfsize" in
    '') ;;
    *)  $echo "ulimitfsize $ulimitfsize" >> $batchdir/$queue/profile ;;
esac
!NO!SUBS!
$eunicefix makeq
chmod 755 makeq
