Summary: xcron -- cron with extensions for power-down and location
Name: xcron
Version: 20070605
Release: 1
License: free for private use
Group: System Environment/Base
Source: http://www.isi.edu/~johnh/SOFTWARE/XCRON/xcron-20070605.tar.gz
Patch1: xcron.redhat.patch

%description
XCRON is an implementation of cron by Geoff Kuenning. Notable
features about xcron are a careful attention to security constraints,
support for a different (and somewhat easier-to-use) crontab format,
and catch-up support for jobs that should have run but didn't because
the machine was off or suspended.  For more details about xcron, see
Geoff's paper (tech report UCLA-CSD-990044 at
<ftp://ftp.cs.ucla.edu/pub/ficus/geoff/ucla_csd_990044.ps.gz>).

LCRON is a small set of extensions to xcron that support location- and
event-triggered actions. Location is primarily determined by network
connectivity, events are things like current power status (A/C or
battery).  Lcron is described in the paper "Location-Aware Scheduling With
Minimal Infrastructure" by John Heidemann and Dhaval Shah in the
Usenix General Technical, June 2000 at
<http://www.isi.edu/~johnh/PAPERS/Heidemann00b.html>


%prep
%setup
%patch1

%build
yes '' | sh Configure
make depend
make

%install
mkdir -p /usr/local/lib/xcron/bin /usr/local/lib/xcron/lib/events /usr/local/lib/xcron/sbin  /usr/local/lib/xcron/spool/atjobs  /usr/local/lib/xcron/spool/crontabs
chmod u=rwx,go= /usr/local/lib/xcron/spool/atjobs  /usr/local/lib/xcron/spool/crontabs
make install
make install.lcron
make install.lcron.redhat
for i in in xat xcrontab tellxcron; do test -L /usr/local/bin/$i && rm -f /usr/local/bin/$i; ln -s /usr/local/lib/xcron/bin/$i /usr/local/bin/$i; done

%post
echo "xcron has been installed and will be started."
echo "See /usr/doc/xcron*/README.lcron for details about how to"
echo "customize your system's location information to use the lcron features."
echo "Starting:"
/etc/rc.d/init.d/xcron start

%files
%doc README
%doc README.lcron
%doc DOC
/etc/rc.d/init.d/xcron
/etc/apmd_proxy
/usr/local/bin/xat
/usr/local/bin/xcrontab
/usr/local/bin/tellxcron
/usr/local/lib/xcron
/usr/local/man/man1/xat.1n
/usr/local/man/man1/xcron.1m
/usr/local/man/man1/xcrontab.1n
/usr/local/man/man1/tellxcron.1m
